/*********************************************
 * Coded by Colin Raffel from code by Guido Socher 
 * Copyright: GPL V2
 *
 * IP/ARP/UDP functions
 *
 * Chip type           : ATMEGA88 with ENC28J60
 *
 * This code is unmodified from Guido's version except for the addition of the
 * buddy function.  This allows the chip to send a message in the absence of a 
 * request.
 * For more information: http://www.experimentalistsanonymous.com/ooscc
 * Guido's site: http://tuxgraphics.org/electronics/200606/article06061.shtml
 *
 *********************************************/
//@{
#ifndef IP_ARP_UDP_H
#define IP_ARP_UDP_H
// you must call this function once before you use any of the other functions:
extern void init_ip_arp_udp(uint8_t *mymac,uint8_t *myip);
//
extern uint8_t eth_type_is_arp_and_my_ip(uint8_t *buf,uint8_t len);
extern uint8_t eth_type_is_ip_and_my_ip(uint8_t *buf,uint8_t len);
extern void make_arp_answer_from_request(uint8_t *buf,uint8_t len);
extern void make_echo_reply_from_request(uint8_t *buf,uint8_t len);
extern void make_udp_reply_from_request(uint8_t *buf,char *data,uint8_t datalen,uint16_t port);
extern void make_udp_to_buddy(uint8_t *buf,char *data,uint8_t datalen,uint16_t port,uint8_t *buddymac,uint8_t *buddyip);

#endif /* IP_ARP_UDP_H */
//@}
